#!/usr/bin/env python
#
#  4-value_hdlr.py  -  Use DX as a glorified calculator.  A test of value
#                      handler callbacks.
#

import sys, os, time, DX

def DXValueHandler( conn, name, value ):
  print "%s is %s" % ( name, value )
  
def AddTwoNumbers( a, b ):
  
  conn = DX.DXLStartDX( DX.DXEXEC + " -execonly", None )
  DX.DXLSetErrorHandler( conn, lambda conn, msg: None )      # Ignore errors
  DX.DXLSend( conn, "num1 = %d + %d;" % (a,b) )
  DX.DXLSend( conn, "DXLOutput( \"result\", num1 );" )
  DX.DXLSetValueHandler( conn, "result", DXValueHandler )
  DX.DXLExecuteOnce ( conn )
  DX.WaitForDXIdle  ( conn )
  DX.DXLRemoveValueHandler( conn, "result" )
  DX.DXLExitDX      ( conn )

if __name__ == "__main__":

  print "Adding 10 and 13..."
  AddTwoNumbers(10,13)
