#!/usr/bin/env python
#
#  5-connect_hdlr.py  -  A test of the broken connection callback.
#

import sys, os, pwd, string, signal, DX

def DXBrokenConnectionCB( conn ):
  print "  <DXBrokenConn>: He's dead, Jim."

def DXErrorCB( conn, msg ):
  print "  <DXErr>       : %s" % msg

def StartDX__ThenShootIt():

  # Sanity check
  if os.uname()[0][:4] == 'IRIX'   :
    ps_cmd = "ps -f | grep dxexec | grep -v grep | awk '{ print $2 }'"
  elif os.uname()[0]   == 'FreeBSD':
    ps_cmd = "ps -x | grep dxexec | grep -v grep | cut -f1 -d' '"
  else:
    print "The ps magic may not work on your OS, so we won't chance it."
    print "If you want to try it, feel free to comment out this check."
    sys.exit(1)

  print "Starting DX...\n"
  conn = DX.DXLStartDX( DX.DXEXEC + " -execonly", None )
  DX.DXLSetBrokenConnectionCallback( conn, DXBrokenConnectionCB )
  DX.DXLSetErrorHandler( conn, DXErrorCB )

  print "Now where did I put that gun...Ah, here it is."

  # This is a hack only fit for testing purposes...beware!
  pids = os.popen( ps_cmd ).read()
  
  DX.DXLExecuteOnce ( conn )

  for pid in string.split( pids ):
    print "\nWabbit season - FIRE!" 
    os.kill( int(pid), signal.SIGTERM )

  # When dxexec goes belly-up, its file descriptor becomes invalid, causing
  #   select or a DXL API call to fail, which the DX wrappers turn into
  #   a DXError exception.
  try:
    DX.WaitForDXIdle  ( conn )
    DX.DXLExitDX      ( conn )
  except DXError, msg:
    print "  <Exception>   :", msg
    pass

#
# The main program
#
if __name__ == "__main__":

  StartDX__ThenShootIt()
